# class Thread::SizedQueue

This class represents queues of specified size capacity. The push operation may be blocked if the capacity is full.

See `Thread::Queue` for an example of how a `Thread::SizedQueue` works.

### Public Class Methods

new(max)
Source

    static VALUE
    rb_szqueue_initialize(VALUE self, VALUE vmax)
    {
        long max;
        struct rb_szqueue *sq = szqueue_ptr(self);

        max = NUM2LONG(vmax);
        if (max <= 0) {
            rb_raise(rb_eArgError, "queue size must be positive");
        }

        RB_OBJ_WRITE(self, szqueue_list(sq), ary_buf_new());
        ccan_list_head_init(szqueue_waitq(sq));
        ccan_list_head_init(szqueue_pushq(sq));
        sq->max = max;

        return self;
    }

Creates a fixed-length queue with a maximum size of `max`.

### Public Instance Methods

<<(object)
Alias for: push
clear ()
Source

    static VALUE
    rb_szqueue_clear(VALUE self)
    {
        struct rb_szqueue *sq = szqueue_ptr(self);

        rb_ary_clear(check_array(self, sq->q.que));
        wakeup_all(szqueue_pushq(sq));
        return self;
    }

Removes all objects from the queue.

close
Source

    static VALUE
    rb_szqueue_close(VALUE self)
    {
        if (!queue_closed_p(self)) {
            struct rb_szqueue *sq = szqueue_ptr(self);

            FL_SET(self, QUEUE_CLOSED);
            wakeup_all(szqueue_waitq(sq));
            wakeup_all(szqueue_pushq(sq));
        }
        return self;
    }

Similar to `Thread::Queue#close`.

The difference is behavior with waiting enqueuing threads.

If there are waiting enqueuing threads, they are interrupted by raising ClosedQueueError(‘queue closed’).

deq
Alias for: pop
empty?
Source

    static VALUE
    rb_szqueue_empty_p(VALUE self)
    {
        struct rb_szqueue *sq = szqueue_ptr(self);

        return RBOOL(queue_length(self, &sq->q) == 0);
    }

Returns `true` if the queue is empty.

enq(object, non_block=false, timeout: nil)
Alias for: push
length
size
Source

    static VALUE
    rb_szqueue_length(VALUE self)
    {
        struct rb_szqueue *sq = szqueue_ptr(self);

        return LONG2NUM(queue_length(self, &sq->q));
    }

Returns the length of the queue.

Also aliased as: size
max ()
Source

    static VALUE
    rb_szqueue_max_get(VALUE self)
    {
        return LONG2NUM(szqueue_ptr(self)->max);
    }

Returns the maximum size of the queue.

max=(number)
Source

    static VALUE
    rb_szqueue_max_set(VALUE self, VALUE vmax)
    {
        long max = NUM2LONG(vmax);
        long diff = 0;
        struct rb_szqueue *sq = szqueue_ptr(self);

        if (max <= 0) {
            rb_raise(rb_eArgError, "queue size must be positive");
        }
        if (max > sq->max) {
            diff = max - sq->max;
        }
        sq->max = max;
        sync_wakeup(szqueue_pushq(sq), diff);
        return vmax;
    }

Sets the maximum size of the queue to the given `number`.

num_waiting ()
Source

    static VALUE
    rb_szqueue_num_waiting(VALUE self)
    {
        struct rb_szqueue *sq = szqueue_ptr(self);

        return INT2NUM(sq->q.num_waiting + sq->num_waiting_push);
    }

Returns the number of threads waiting on the queue.

pop(non_block=false, timeout: nil)
Source

    # File thread_sync.rb, line 36
    def pop(non_block = false, timeout: nil)
      if non_block && timeout
        raise ArgumentError, "can't set a timeout if non_block is enabled"
      end
      Primitive.rb_szqueue_pop(non_block, timeout)
    end

Retrieves data from the queue.

If the queue is empty, the calling thread is suspended until data is pushed onto the queue. If `non_block` is true, the thread isn’t suspended, and `ThreadError` is raised.

If `timeout` seconds have passed and no data is available `nil` is returned. If `timeout` is `0` it returns immediately.

Also aliased as: deq, shift
push(object, non_block=false, timeout: nil)
Source

    # File thread_sync.rb, line 59
    def push(object, non_block = false, timeout: nil)
      if non_block && timeout
        raise ArgumentError, "can't set a timeout if non_block is enabled"
      end
      Primitive.rb_szqueue_push(object, non_block, timeout)
    end

Pushes `object` to the queue.

If there is no space left in the queue, waits until space becomes available, unless `non_block` is true. If `non_block` is true, the thread isn’t suspended, and `ThreadError` is raised.

If `timeout` seconds have passed and no space is available `nil` is returned. If `timeout` is `0` it returns immediately. Otherwise it returns `self`.

Also aliased as: enq, <<
shift
Alias for: pop
length
size

Returns the length of the queue.

Alias for: length